// Configdlg.cpp : implementation file
//

#include "stdafx.h"
#include "wrap.h"
#include "Configdlg.h"
#include "threads.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigdlg dialog


CConfigdlg::CConfigdlg(CWnd* pParent /*=NULL*/)
        : CDialog(CConfigdlg::IDD, pParent)
{
        //{{AFX_DATA_INIT(CConfigdlg)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CConfigdlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CConfigdlg)
                // NOTE: the ClassWizard will add DDX and DDV calls here
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigdlg, CDialog)
        //{{AFX_MSG_MAP(CConfigdlg)
        ON_BN_CLICKED(ID_CONFIG_OK, OnConfigOk)
        ON_BN_CLICKED(ID_CONFIG_CANCEL, OnConfigCancel)
        ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CONFIG_MINIMIZE, OnConfigMinimize)
	ON_BN_CLICKED(IDC_CONFIG_HIDE, OnConfigHide)
	ON_EN_CHANGE(IDC_CERT, OnChangeCert)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_EN_CHANGE(IDC_LOG, OnChangeLog)
	ON_BN_CLICKED(IDC_BROWSE2, OnBrowse2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigdlg message handlers

void CConfigdlg::OnConfigOk() 
{
    /*    this->quitway=0;
        PostMessage(WM_CLOSE, 0, 0);
  */    this->EndDialog(IDOK);  
}

void CConfigdlg::OnConfigCancel() 
{
/*        this->quitway=1;
        PostMessage(WM_CLOSE, 0, 0);
  */    this->EndDialog(IDCANCEL);      
}


BOOL CConfigdlg::OnInitDialog() 
{
        CDialog::OnInitDialog();
		autohide=hoe_threadOwner->autohide;
        autominimize=hoe_threadOwner->autominimize;
		certfile=hoe_threadOwner->certfile;
		logfile=hoe_threadOwner->logfile;
		this->SetValues();
        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfigdlg::OnClose() 
{
 CDialog::OnClose();
}

void CConfigdlg::SetValues()
{
	CButton* pCheck = (CButton*) GetDlgItem(IDC_CONFIG_MINIMIZE);
	pCheck->SetCheck(autominimize);
	pCheck = (CButton*) GetDlgItem(IDC_CONFIG_HIDE);
	pCheck->SetCheck(autohide);

	CEdit *edit=(CEdit*)this->GetDlgItem(IDC_CERT);
	ASSERT(edit);
	edit->SetWindowText(certfile);

	edit=(CEdit*)this->GetDlgItem(IDC_LOG);
	ASSERT(edit);
	edit->SetWindowText(logfile);
	
	//BOOL b = ((pCheck->GetState() & 0x003) != 0);	
}

void CConfigdlg::OnConfigMinimize() 
{
	autominimize=!autominimize;	
}

void CConfigdlg::OnConfigHide() 
{
	autohide=!autohide;	
}

void CConfigdlg::OnChangeCert() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	CEdit *edit=(CEdit*)this->GetDlgItem(IDC_CERT);
	ASSERT(edit);
//	edit->SetWindowText(certfile);
	
	edit->GetWindowText(certfile);
	// TODO: Add your control notification handler code here
	
}

void CConfigdlg::OnBrowse() 
{
 CFileDialog ff(TRUE,".pem",certfile,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"PEM file (*.pem)|*.pem",this);;
 if (ff.DoModal()==IDOK) {
  certfile=ff.GetPathName();
  SetValues();
 }
 
}

void CConfigdlg::OnChangeLog() 
{

	CEdit *edit=(CEdit*)this->GetDlgItem(IDC_LOG);
	ASSERT(edit);	
	edit->GetWindowText(logfile);	
}

void CConfigdlg::OnBrowse2() 
{
 CFileDialog ff(TRUE,".log",logfile,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"LOG file (*.log)|*.log|All files (*.*)|*.*",this);;
 if (ff.DoModal()==IDOK) {
  logfile=ff.GetPathName();
  SetValues();
 }
 	
}
