// ConnectionDLG.cpp : implementation file
//

#include "stdafx.h"
#include "wrap.h"
#include "ConnectionDLG.h"
#include "wrapdlg.h"
#include "threads.h"

// CConnectionDLG dialog

IMPLEMENT_DYNAMIC(CConnectionsDlg, CDialog)
CConnectionsDlg::CConnectionsDlg(CWnd* pParent /*=NULL*/)
: CDialog(CConnectionsDlg::IDD, pParent)
{
	this->m_myList=new CListViewEx();
}

CConnectionsDlg::~CConnectionsDlg()
{
//	delete this->m_myList;
}

void CConnectionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//this crap doesnt work, screw it
/*    //{{AFX_DATA_MAP(CConnectionsDlg)
	DDX_Control(pDX, IDC_LIST, m_ConnList);
    //}}AFX_DATA_MAP
*/
}


BEGIN_MESSAGE_MAP(CConnectionsDlg, CDialog)
	ON_BN_CLICKED(IDKILL, OnBnClickedKill)
END_MESSAGE_MAP()


// CConnectionDLG message handlers
void CConnectionsDlg::RefreshItems() {
//	CListViewEx* lve = &this->m_ConnList;
	CListViewEx* lve = this->m_myList;
	ASSERT(lve);

	CListCtrl& p=lve->GetListCtrl();
	ASSERT(&p);

	p.DeleteAllItems();
	int i=0;

	//we need to lock mutex here !, and one day we will :)
	CSingleLock sLock(&hoe_threadOwner->m_threadsmutex);
	sLock.Lock();
	CString str;
	CWrapThread *ctemp;
	DWORD   dwStatus;

	POSITION pos=hoe_threadOwner->m_pWrapThreads->GetHeadPosition();
	while (pos!=NULL) {
		ctemp=hoe_threadOwner->m_pWrapThreads->GetAt(pos);
		VERIFY(::GetExitCodeThread(ctemp->m_hThread, &dwStatus));
		if (dwStatus == STILL_ACTIVE) {
			str.Format("%d.",i+1);
			p.InsertItem(i,str);
			p.SetItemText(i,1,ctemp->hoe_threadConf.label);
			p.SetItemData(i,(DWORD_PTR)ctemp);
			str.Format("%s:%d",ctemp->hoe_threadConf.fromhost,ctemp->hoe_threadConf.fromport);
			p.SetItemText(i,2,str);
			str.Format("%s:%d",ctemp->hoe_threadConf.outhost,ctemp->hoe_threadConf.outport);
			p.SetItemText(i,3,str);
			if (ctemp->hoe_threadConf.type) str="FTP Proxy"; else
				str="Tunnel";
			p.SetItemText(i,4,str);
		}
		hoe_threadOwner->m_pWrapThreads->GetNext(pos);
		i++;
	}
	sLock.Unlock();
	return;
}

BOOL CConnectionsDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();
	m_myList->SubclassDlgItem(IDC_LIST,this);
//	CListViewEx* lve = &this->m_ConnList;
	CListViewEx* lve = this->m_myList;
	ASSERT(lve);
	lve->SetFullRowSel(true);
	CListCtrl& p=lve->GetListCtrl();
	ASSERT(p);

	CString strText;
	p.InsertColumn(1,"Num.",LVCFMT_CENTER,40,-1);
	p.InsertColumn(2,"Name",LVCFMT_CENTER,100,-1);
	p.InsertColumn(3,"From",LVCFMT_CENTER,150,-1);
	p.InsertColumn(4,"To",LVCFMT_CENTER,150,-1);
	p.InsertColumn(5,"Type",LVCFMT_CENTER,70,-1);
	this->RefreshItems();
	return false;
}

void CConnectionsDlg::OnBnClickedKill()
{
	// TODO: Add your control notification handler code here
	CListViewEx* lve = this->m_myList;
	ASSERT(lve);

	CListCtrl& p=lve->GetListCtrl();
	ASSERT(&p);
	POSITION pos=p.GetFirstSelectedItemPosition();
	int i=p.GetNextSelectedItem(pos);
	if (i!=-1) {
	CWrapThread *ctemp=(CWrapThread *)p.GetItemData(i);
	if (ctemp!=NULL) {
		ctemp->hoe_threadDone=true;
	}
	}
}
