// SSLConn.h: interface for the CSSLConn class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include <openssl/ssl.h>
#include <openssl/err.h>

#include "Connection.h"

class CSSLConn : public CConnection  
{
public:
	CSSLConn(int sck,SSL *ssl);
	virtual ~CSSLConn();
    int read(void *buf,int count);
    int write(const void *buf,int count);
	int close();
private :
  SSL *sslcon;

};

