#pragma once

class CWrapThread;
class CListenThread;
class CThreadConfig;
class CMainDlg;
class CConnectionsDlg;
typedef CTypedPtrList<CPtrList,CThreadConfig*> CThreadConfigList;

#include "hoeedit.h"
#include "connectionDlg.h"

#include <openssl/ssl.h>

class CThreadConfig {
  //  int magic;
	//struct _CThreadConfig *next;
public :
	struct sockaddr_in sa;
	int sd;
	CString label;
	int type, inport,outport,fromport;
	BOOL enabled,sslin,sslout,ftpreject;
	int ftptype;
	CString inhostreal,inhost,inhostip,outhost,outhostip;
	CString fromhost,fromip;

};


/*struct CWrapThreads {
  //  int magic;
	//struct _CWrapThreads *next;
	CWrapThread* thread;
} ;
*/

typedef CTypedPtrList<CPtrList,CWrapThread*> CWrapThreadList;


/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

class CMainDlg : public CDialog
{
	// Construction
public:
	CMainDlg(CWnd* pParent = NULL);  // standard constructor
	
	// Dialog Data
	//{{AFX_DATA(CMainDlg)
	enum { IDD = IDD_WRAP_DIALOG };
	CHoEEdit	m_HOE;
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL
	
public:
	SSL_CTX *ssl_ctx,*ssl_ctx_server;
//	CMutex m_mutex;
	//CWrapThread* m_pWrapThread;
	CListenThread* m_pListenThread;
	void UpdateTrayIcon(CString szIconStr);
	void DeleteTrayIcon();
	BOOL ReadConfigFile();
	BOOL WriteConfigFile();
	BOOL autohide,autominimize;
	CString logfile;
    CString certfile;	
//	CMutex m_pMutexWrapThreads;
    CMutex m_mutex,m_threadsmutex;
//	CWrapThreads *m_pWrapThreads;
	//CThreadConfig *m_pThreadConfigs;
	CWrapThreadList *m_pWrapThreads;
	CThreadConfigList *m_pThreadConfigs;
	CConnectionsDlg *m_pConnectionsDlg;
	int m_pConnections;
	//      CListenThreads *m_pListenThreads;
	
	void AddToLog(LPCTSTR szBuffer);
	
	//  void OnPriorityChange(UINT nID);
	
	// Implementation
protected:
	HICON m_hIcon;
	int m_hQuitting;	
	// Generated message map functions
	//{{AFX_MSG(CMainDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnClose();
	afx_msg void OnPause();
	afx_msg void OnStartstop();
	afx_msg void OnButtonQuit();
	afx_msg void OnTrayMenuQuit();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnTrayMenuAbout();
	afx_msg LRESULT OnTrayMsg(WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnConnectionNews(WPARAM , LPARAM lParam);
	afx_msg void OnButtonConfig();
	afx_msg void OnButtonServices();
	afx_msg void OnClear();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnButtonConnections();
};
