#include "stdafx.h"
#include "ftplines.h"

CFTPLines::CFTPLines(CConnection *ccon,int &m_bDone)
{
 this->ccon=ccon;
 this->m_bDone=&m_bDone;
 this->log="";
}

CFTPLines::~CFTPLines(void)
{
	ccon->close();
	delete ccon;
	ccon=NULL;
}

void CFTPLines::resetlog(void)
{
	log="";
	lastline="";
}

int CFTPLines::postcommand(CString s) {
	if (s.Left(5)=="PASS ") {
      log=log+"COMMAND > PASS <censored>\r\n";
	} else
	log=log+"COMMAND >"+s+"\r\n";
	return ccon->write(s+"\r\n");
}

int CFTPLines::getreply(void)
//returns 0-ok 1-error
{
	int i;
	CString str;	

	while (TRUE) {
		i=ccon->GetLine(&str);
		if ((i==GETLINE_ERROR)||(*m_bDone)) {
			return 1;
		}
		if (i==GETLINE_NOT_WHOLE_LINE) continue;
		if (i==GETLINE_NO_DATA) {
			Sleep(1);
			continue;
		}
		log=log+str+"\r\n";
		if (str[3]=='-') {
//line wasnt final reply
			continue;
		} else
			if (str[3]==' ') {
              lastline=str;
			  return 0;
			} else {
              return 1;
			}
	}
	//avoid warning
	return 0;
}
